<?php

	// 設定項目
	$consumer_key = '' ;	// コンシューマーキー
	$access_token = '' ;	// アクセストークン
	$request_url = 'https://getpocket.com/v3/get' ;		// リクエストURL
	$request_method = 'POST' ;							// メソッド

	// パラメーター
	$params = array(
		'state' => 'all' ,							// 未読の記事のみ
	) ;
 
	// パラメーターにコンシューマーキーとアクセストークンを追加
	$params = array_merge( $params , array( 'consumer_key' => $consumer_key , 'access_token' => $access_token , ) ) ;

	// コンテキスト
	$context = array(
		'http' => array(
			'method' => $request_method ,
			'content' => http_build_query( $params ) ,
		)
	) ;

	// アイテムデータをJSON形式で取得する (CURLを使用)
	$curl = curl_init() ;

	// オプションのセット
	curl_setopt( $curl , CURLOPT_URL , $request_url ) ;
	curl_setopt( $curl , CURLOPT_HEADER, 1 ) ; 
	curl_setopt( $curl , CURLOPT_CUSTOMREQUEST , $context['http']['method'] ) ;			// メソッド
	curl_setopt( $curl , CURLOPT_SSL_VERIFYPEER , false ) ;								// 証明書の検証を行わない
	curl_setopt( $curl , CURLOPT_RETURNTRANSFER , true ) ;								// curl_execの結果を文字列で返す
	curl_setopt( $curl , CURLOPT_POSTFIELDS , $context['http']['content'] ) ;			// リクエストボディ
	curl_setopt( $curl , CURLOPT_TIMEOUT , 5 ) ;										// タイムアウトの秒数

	// 実行
	$res1 = curl_exec( $curl ) ;
	$res2 = curl_getinfo( $curl ) ;

	// 終了
	curl_close( $curl ) ;

	// 取得したデータ
	$json = substr( $res1, $res2['header_size'] ) ;										// 取得したデータ(JSONなど)
	$header = substr( $res1, 0, $res2['header_size'] ) ;								// レスポンスヘッダー (検証に利用したい場合にどうぞ)

	// HTML用
	$html = '' ;

	// JSONデータをオブジェクトではなく、連想配列形式に変換する
	$array = json_decode( $json , true ) ;

	// エラー判定
	if( !isset($array['list']) )
	{
		$html .= '<p>データを取得できませんでした…。設定を再確認して下さい。</p>' ;
	}

	// アイテム個数が15件以下の場合はエラー
	elseif( 15 > $array['list'] )
	{
		$html .= "もっとpocketしてから来て下さい!!";
	}

	else
	{
		// アイテムリストの配列を変数に格納
		$item_list = $array['list'] ;
 
		// アイテム数を調べる
		$item_count = count( $item_list ) ;

		// アイテム配列の中から、ランダムで10個のキーを取得
		$random_list = array_rand( $item_list ,10 ) ;
 
		// HTMLを作成
		$html .= '<h2>実行結果</h2>' ;
		$html .= '<p>登録しているアイテムの中からランダムで10個のアイテムをピックアップしました。もう一度試すには、<a href="' . explode( '?' , $_SERVER['REQUEST_URI'] )[0] . '">こちら</a>をクリックして下さい。</p>' ;

		// 選ばれたキーのアイテムを出力する
		foreach( $random_list as $key )
		{
			// データが揃ってなければパス
			if( !isset($item_list[ $key ]['item_id']) || !isset($item_list[ $key ]['resolved_title']) || !isset($item_list[ $key ]['resolved_url']) || !isset($item_list[ $key ]['favorite']) || !isset($item_list[ $key ]['time_added']) )
			{
				continue ;
			}

			// 各データの整理
			$id = $item_list[ $key ]['item_id'] ;								// アイテムのID
			$title = $item_list[ $key ]['resolved_title'] ;						// アイテムのタイトル
			$url = $item_list[ $key ]['resolved_url'] ;							// アイテムのURL
			$fav = ( $item_list[ $key ]['favorite']== 1 ) ? '★ ' : '' ;		// お気に入りにしているか？
			$date = $item_list[ $key ]['time_added'] ;							// pocketした日付

			// 日付を整形
			$date = date( 'Y/m/d H:i' , $date ) ;
  
			// ブラウザに出力
			$html .= '<dl>' ;
			$html .= 	'<dt>アイテムID</dt>' ;
			$html .= 		'<dd>' . $id . '</dd>' ;
			$html .= 	'<dt>タイトル</dt>' ;
			$html .= 		'<dd>' . $fav . $title . '</dd>' ;
			$html .= 	'<dt>URLアドレス</dt>' ;
			$html .= 		'<dd><a href="' . $url . '" target="_blank">' . $url . '</a></dd>' ;
			$html .= 	'<dt>登録した日付</dt>' ;
			$html .= 		'<dd>' . $date . '</dd>' ;

			// 画像
			if( isset( $item_list[ $key ]['image']['src'] ) && !empty( $item_list[ $key ]['image']['src'] ) )
			{
				$html .= 	'<dt>イメージ</dt>' ;
				$html .= 		'<dd><img class="_img" src="' . $item_list[ $key ]['image']['src'] . '"></dd>' ;
			}

			$html .= '</dl>' ;
		}
	}

	// 取得したデータ
	$html .= '<h2>取得したデータ</h2>' ;
	$html .= '<p>下記のデータを取得できました。</p>' ;
	$html .= 	'<h3>JSON</h3>' ;
	$html .= 	'<p><textarea rows="8">' . $json . '</textarea></p>' ;
	$html .= 	'<h3>レスポンスヘッダー</h3>' ;
	$html .= 	'<p><textarea rows="8">' . $header . '</textarea></p>' ;

	// アプリケーション連携の解除
	$html .= '<h2>アプリケーション連携の解除</h2>' ;
	$html .= '<p>このアプリケーションとの連携は、下記設定ページで解除することができます。</p>' ;
	$html .= '<p><a href="https://getpocket.com/connected_applications" target="_blank">https://getpocket.com/connected_applications</a></p>' ;

?><!DOCTYPE html>
<html>
	<head>
		<meta charset="UTF-8">
		<meta name="robots" content="noindex,nofollow">

		<!-- ビューポートの設定 -->
		<meta name="viewport" content="width=device-width, initial-scale=1.0">

		<title>pocket APIでアイテムをランダムに取得するサンプルデモ</title><!-- 

/********************************************************************************

	SYNCER 〜 知識、感動をみんなと同期(Sync)するブログ

	* 配布場所
	https://syncer.jp/pocket-api-matome

	* 動作確認
	https://syncer.jp/pocket-api-matome/demo/get-item-random.php

	* 最終更新日時
	2015/08/03 04:09

	* 作者
	あらゆ

	** 連絡先
	Twitter: https://twitter.com/arayutw
	Facebook: https://www.facebook.com/arayutw
	Google+: https://plus.google.com/114918692417332410369/
	E-mail: info@syncer.jp

	※ バグ、不具合の報告、提案、ご要望など、お待ちしております。
	※ 申し訳ありませんが、ご利用者様、個々の環境における問題はサポートしていません。

********************************************************************************/

		-->
	</head>
<body>



<?php echo $html ?>


<p style="text-align:center"><a href="https://syncer.jp/pocket-api-matome">配布元: Syncer</a></p>






</body>
</html>
