<?php

	// 設定項目
	$consumer_key = '' ;	// コンシューマーキー
	$access_token = '' ;	// アクセストークン
	$request_url = 'https://getpocket.com/v3/send' ;		// リクエストURL
	$request_method = 'POST' ;								// メソッド

	// アクションのJSON
	$actions = array(
		array(
			'action' => 'add' ,
			'url' => 'https://syncer.jp/' ,
		) ,
		array(
			'action' => 'add' ,
			'url' => 'https://syncer.jp/hatebu-api-matome' ,
		) ,
		array(
			'action' => 'add' ,
			'url' => 'https://syncer.jp/brand-logos' ,
		) ,
	) ;

	// 多次元の連想配列をJSONデータに変換する
	$actions_json = json_encode( $actions ) ;

	// パラメーター
	$params = array(
		'actions' => $actions_json ,								// アクションのJSON
	) ;
 
	// パラメーターにコンシューマーキーとアクセストークンを追加
	$params = array_merge( $params , array( 'consumer_key' => $consumer_key , 'access_token' => $access_token , ) ) ;

	// コンテキスト
	$context = array(
		'http' => array(
			'method' => $request_method ,
			'content' => http_build_query( $params ) ,
		)
	) ;

	// アイテムデータをJSON形式で取得する (CURLを使用)
	$curl = curl_init() ;

	// オプションのセット
	curl_setopt( $curl , CURLOPT_URL , $request_url ) ;
	curl_setopt( $curl , CURLOPT_HEADER, 1 ) ; 
	curl_setopt( $curl , CURLOPT_CUSTOMREQUEST , $context['http']['method'] ) ;			// メソッド
	curl_setopt( $curl , CURLOPT_SSL_VERIFYPEER , false ) ;								// 証明書の検証を行わない
	curl_setopt( $curl , CURLOPT_RETURNTRANSFER , true ) ;								// curl_execの結果を文字列で返す
	curl_setopt( $curl , CURLOPT_POSTFIELDS , $context['http']['content'] ) ;			// リクエストボディ
	curl_setopt( $curl , CURLOPT_TIMEOUT , 5 ) ;										// タイムアウトの秒数

	// 実行
	$res1 = curl_exec( $curl ) ;
	$res2 = curl_getinfo( $curl ) ;

	// 終了
	curl_close( $curl ) ;

	// 取得したデータ
	$json = substr( $res1, $res2['header_size'] ) ;										// 取得したデータ(JSONなど)
	$header = substr( $res1, 0, $res2['header_size'] ) ;								// レスポンスヘッダー (検証に利用したい場合にどうぞ)

	// HTML用
	$html = '' ;

	// JSONデータをオブジェクト形式に変換する
	$obj = json_decode( $json ) ;

	// エラー判定
	if( !isset($obj->status) || !$obj->status )
	{
		$html .= '<p>リクエストに失敗しました…。</p>' ;
	}
	else
	{
		// HTMLを作成
		$html .= '<h2>実行結果</h2>' ;
		$html .= '<p>リクエストに成功しました。</p>' ;

		// リクエストしたデータ
		$html .= '<h2>リクエストしたデータ</h2>' ;
		$html .= '<p>下記内容のアクションでリクエストを送りました。</p>' ;
		$html .= 	'<p><textarea rows="8">' . $actions_json . '</textarea></p>' ;
	}

	// 取得したデータ
	$html .= '<h2>取得したデータ</h2>' ;
	$html .= '<p>下記のデータを取得できました。</p>' ;
	$html .= 	'<h3>JSON</h3>' ;
	$html .= 	'<p><textarea rows="8">' . $json . '</textarea></p>' ;
	$html .= 	'<h3>レスポンスヘッダー</h3>' ;
	$html .= 	'<p><textarea rows="8">' . $header . '</textarea></p>' ;

	// アプリケーション連携の解除
	$html .= '<h2>アプリケーション連携の解除</h2>' ;
	$html .= '<p>このアプリケーションとの連携は、下記設定ページで解除することができます。</p>' ;
	$html .= '<p><a href="https://getpocket.com/connected_applications" target="_blank">https://getpocket.com/connected_applications</a></p>' ;

?><!DOCTYPE html>
<html>
	<head>
		<meta charset="UTF-8">
		<meta name="robots" content="noindex,nofollow">

		<!-- ビューポートの設定 -->
		<meta name="viewport" content="width=device-width, initial-scale=1.0">

		<title>pocket APIでアイテムを変更するサンプルデモ</title><!-- 

/********************************************************************************

	SYNCER 〜 知識、感動をみんなと同期(Sync)するブログ

	* 配布場所
	https://syncer.jp/pocket-api-matome

	* 動作確認
	https://syncer.jp/pocket-api-matome/demo/modify-item.php

	* 最終更新日時
	2015/08/03 04:11

	* 作者
	あらゆ

	** 連絡先
	Twitter: https://twitter.com/arayutw
	Facebook: https://www.facebook.com/arayutw
	Google+: https://plus.google.com/114918692417332410369/
	E-mail: info@syncer.jp

	※ バグ、不具合の報告、提案、ご要望など、お待ちしております。
	※ 申し訳ありませんが、ご利用者様、個々の環境における問題はサポートしていません。

********************************************************************************/

		-->
	</head>
<body>



<?php echo $html ?>


<p style="text-align:center"><a href="https://syncer.jp/pocket-api-matome">配布元: Syncer</a></p>






</body>
</html>
